/** 
 * @template T
 * @param {T[]} arr
 * @param {(x:T)=>Number} key
 * @returns {T}
 * */
function argmin(arr=[],key=parseInt)
{
    var k=arr.map(x=>key(x)).map(x=>isNaN(x)?Infinity:x)
    var kmin=Math.min(...(k.flat()))
    return k.findIndex(x=>x==kmin)
}
/**
 * @template T
 * @param {T[]} arr
 * @param {(x:T)=>Number} key
 * @returns {T}
 */
function min(arr=[],key=parseInt)
{return arr[argmin(arr,key)]}

function fuzzy(x="")
{return new RegExp(x.split("").reduce((a,b)=>a+".*?"+b), "i")}










/** 
 * @returns {String[]}
*/
function enumStat(x=Stats.Building)
{return Object.keys(x).map(i=>x[i].Id)}

function itemFromName(stat=Stats.Building,name="")
{
    var k=min( Object.keys(stat).filter(i=>fuzzy(name).test(i)), i=>i.length )
    return stat[k].Id
}
/**"hvycan py htk" -> ["Body11ABT","HalfTrack",0,0,"Cannon375mmMk1"]*/
function templateFromName(x="")
{
    if (x.startsWith("*"))
    {
        x=x.slice(1)
        var cybwpn=Object.keys(Stats.Weapon).filter(i=>Stats.Weapon[i].Id.startsWith("Cyb"))
        var weapons=[Stats.Weapon[min( cybwpn.filter(i=>fuzzy(x).test(i)), i=>i.length )].Id]
        var body=(weapons[0].includes("Hvywpn"))?"CyborgHeavyBody":"CyborgLightBody"
        var prop="CyborgLegs"
    }
    else
    {
        var y=x.split(new RegExp(" +"))//weapon body prop
        var body=itemFromName(Stats.Body,y[y.length-2])
        var prop=itemFromName(Stats.Propulsion,y[y.length-1])
        var weapons=y.slice(0,y.length-2).map(i=>itemFromName(Stats.Weapon,i))
    }
    return [body,prop,0,0,...weapons]
}


/** ["Body11ABT","HalfTrack",0,0,"Cannon375mmMk1"] -> "Heavy Cannon Python Half Track"*/
function nameFromTemplate(...template)
{
    return [template[4],template[0],template[1]].join(" ")
}


function shPower(from, count)
{
    setPower(playerPower(from)+parseFloat(count),from)
}
function shPowerModifier(from, coef)
{
    //85 100 125
    setPowerModifier(coef,from)
}

function shAddDroid(from, ...argv)
{
    var home=startPositions[from]
    var template=templateFromName(argv.join(" "))
    var pos=pickStructLocation(enumDroid(from)[0],"A0HardcreteMk1Wall",home.x,home.y)
    addDroid(from,pos.x,pos.y,nameFromTemplate(...template),...template)
}
function shAddStructure(from, name)
{
    var home=startPositions[from]
    var sname=itemFromName(Stats.Building,name)
    var pos=pickStructLocation(enumDroid(from)[0],sname,home.x,home.y)
    addStructure(sname,from,pos.x*128,pos.y*128)
}


function shLimitDroid(from,...argv)
{
    if (argv.length==1) var [typ,count]=[DROID_ANY,argv[0]]
    if (argv.length==2) var [typ,count]=[DROID_CONSTRUCT,argv[1]]
    setDroidLimit(from,count,typ) 

}
function shLimitStructure(from,name,count)
{
    var sname=itemFromName(Stats.Building,name)
    setStructureLimits(sname,count,from)
}


function u1()
{
    /** unlimited */
    zsh(0,"* power 100000")
    zsh(0,"* limit 10000")
    zsh(0,"* limit t 10000")
    zsh(0,"* sadd satuk")

    zsh(0,"* slimit powergen 1000")
    zsh(0,"* slimit resfact 1000")
    
    zsh(0,"* slimit fact 1000")
    zsh(0,"* slimit cybfact 1000")
    zsh(0,"* slimit vfact 1000")

    zsh(0,"* slimit repair 1000")
}

function u2()
{
    /** MG hovers */
    zsh(0,"* 20 add macgun vp hv")
    zsh(0,"* 20 add hmg b hv")
    zsh(0,"* 20 add asugun leo hv")
    zsh(0,"* 20 add tasgun rel hv")
}

function u3()
{
    /** fortness */
    zsh(0,"* 20 sadd shaker")
    zsh(0,"* 20 sadd archan")
    zsh(0,"* 10 sadd missfort")
}


cmd={
    power:shPower,
    powermod:shPowerModifier,

    add:shAddDroid,
    sadd:shAddStructure,

    limit:shLimitDroid,
    slimit:shLimitStructure,

    u1:u1,
    u2:u2,
    u3:u3,  
}
var lastErr=0
/**
 * @param {Number} from 
 * @param  {...String} argv 
 */
function _sh(from, ...argv)
{
    //console(JSON.stringify([from,argv]))
    var [a,x]=[argv[0],argv.slice(1)]
    if (parseInt(a)==a)
        {
            for(var i=0;i<parseInt(a);i++)
                sh(from, ...x)
            return
        }
    if (a=="*")
        {
            for(var i=0;i<playerData.length;i++)
                sh(i, ...x)
            return
        }

    try
    {
        cmd[a](from, ...x)
    } 
    catch(error)
    {
        if (gameTime-lastErr<100)return
        console("error:",a,JSON.stringify(x))
        console(error)
        lastErr=gameTime
    }
}
include("multiplay/script/mods/sync.js");
var sh=synchronize(_sh)

function zsh(from,cmd="")
{
    var argv=cmd.trimStart().trimEnd().split(new RegExp(" +"))
    console(argv.join(" "))
    sh(from,...argv)
}



/** An event that is run whenever a chat message is received. The ```from``` parameter is the
player sending the chat message. For the moment, the ```to``` parameter is always the script
player. 
* @param {Number} from
* @param {Number} to
* @param {String} message
*/
function eventChat(from, to, message) 
{
    if (to!=me)return
    if (!message.startsWith("/"))return
    zsh(from,message.slice(1))
}
