/** charcodes of JSON.stringify([func.name,argv]) */
const syncBuffer=[]
/** { func.name : func }*/
const syncMapping={}
/** layers of synchronized call*/
var syncLevel=0

function eventSyncRequest(from,req_id, x, y, obj_id, obj_id2)
{
    if (req_id<0){return}
    if (req_id==0)
    {
        var [fname,argv]=JSON.parse(String.fromCharCode(...syncBuffer.splice(0)))
        syncLevel+=1
        try{syncMapping[fname](...argv.map(i=>i===null?undefined:i))}
        catch{}
        syncLevel-=1
        return
    }
    syncBuffer.push(req_id)
}

/** func must have "name" attribute and warpped in all client
 * - `undefined`->`null` after stringify,so make `null`->'undefined` at parse to adapt default arg
 * @template T
 * @param {T} func 
 * @returns {T}
 */
function synchronize(func)
{
    syncMapping[func.name]=func
    function func2(...argv)
    {
        if (syncLevel>0)return func(...argv)//already synchronized
        var argx=JSON.stringify([func.name,argv])
        for (const i in argx)
        {syncRequest(argx.charCodeAt(i),0,0)}
        syncRequest(0,0,0)
    }
    return func2
}


